<template>
  <div :class="{fullscreen:fullscreen}" class="tinymce-container" :style="{width:containerWidth}">
    <textarea :id="tinymceId" class="tinymce-textarea" />
    <div class="editor-custom-btn-container">

      <el-upload
        ref="upload"
        :multiple="true"
        action="/api/artical/uploadAttach"
        :auto-upload="true"
        :show-file-list="false"
        :headers="headers"
        class="editor-upload-btn mlr10"
        :before-upload="uploadBefore"
        :on-success="uploadSuccess"
      >
        <el-button size="small" type="primary" >
          添加附件
        </el-button>
      </el-upload>

      <editorImage color="#1890ff" class="editor-upload-btn mlr10" @successCBK="imageSuccessCBK" />
    </div>
  </div>
</template>

<script>
/**
 * docs:
 * https://panjiachen.github.io/vue-element-admin-site/feature/component/rich-editor.html#tinymce
 */
import editorImage from './components/EditorImage'
import editorFile from './components/EditorFile'
import plugins from './plugins'
import toolbar from './toolbar'
import load from './dynamicLoadScript'
import axios from 'axios';
// import tinymceCDN from '@/assets/tinymce.min.js'

// why use this cdn, detail see https://github.com/PanJiaChen/tinymce-all-in-one
const tinymceCDN = 'https://cdn.jsdelivr.net/npm/tinymce-all-in-one@4.9.3/tinymce.min.js'

export default {
  name: 'Tinymce',
  components: { editorImage, editorFile },
  props: {
    id: {
      type: String,
      default: function() {
        return 'vue-tinymce-' + +new Date() + ((Math.random() * 1000).toFixed(0) + '')
      }
    },
    value: {
      type: String,
      default: ''
    },
    toolbar: {
      type: Array,
      required: false,
      default() {
        return []
      }
    },
    uploadUrl: {
        type: String,
        required: true
    },
    headers:{
      type: Object,
      required: true,
      default() {
        return {}
      }
    },
    menubar: {
      type: String,
      default: 'file edit insert view format table'
    },
    height: {
      type: [Number, String],
      required: false,
      default: 360
    },
    width: {
      type: [Number, String],
      required: false,
      default: 'auto'
    }
  },
  data() {
    return {
      hasChange: false,
      hasInit: false,
      tinymceId: this.id,
      fullscreen: false,
      languageTypeList: {
        'en': 'en',
        'zh': 'zh_CN',
        'es': 'es_MX',
        'ja': 'ja'
      }
    }
  },
  computed: {
    containerWidth() {
      const width = this.width
      if (/^[\d]+(\.[\d]+)?$/.test(width)) { // matches `100`, `'100'`
        return `${width}px`
      }
      return width
    }
  },
  watch: {
    value(val) {
      if (!this.hasChange && this.hasInit) {
        this.$nextTick(() =>
          window.tinymce.get(this.tinymceId).setContent(val || ''))
      }
    }
  },
  mounted() {
    this.init()
  },
  activated() {
    if (window.tinymce) {
      this.initTinymce()
    }
  },
  deactivated() {
    this.destroyTinymce()
  },
  destroyed() {
    this.destroyTinymce()
  },
  methods: {
    init() {
      load(tinymceCDN, (err) => {
        if (err) {
          this.$message.error(err.message)
          return
        }
        this.initTinymce()
      })
    },
    initTinymce() {
      const _this = this

      window.tinymce.init({
        selector: `#${this.tinymceId}`,
        language: this.languageTypeList['zh'],
        height: this.height,
        body_class: 'panel-body',
        object_resizing: true,
        // extended_valid_elements: 'img[style|class|src|border|alt|title|hspace|vspace|width|height|align|name|loading]',
        toolbar: this.toolbar.length > 0 ? this.toolbar : toolbar,
        menubar: this.menubar,
        plugins: plugins,
        content_css : "tinymce.css",
        entity_encoding : "raw",
        remove_linebreaks : false,
        forced_root_block: false,
        force_br_newlines: true,
        // invalid_elements : "p, div, span",
        imagetools_toolbar: 'editimage',
        end_container_on_empty_block: true,
        powerpaste_word_import: 'clean',
        paste_merge_formats: false,
        code_dialog_height: 500,
        code_dialog_width: 900,
        advlist_bullet_styles: 'square',
        advlist_number_styles: 'default',
        imagetools_cors_hosts:  ['smoa.ndjsxh.cn:8888'],
        default_link_target: '_blank',
        // table_default_styles: {
        // 	width: '80%',
        //   border: '1',
        //   cellspacing:"0",
        //   cellpadding:"0"
        // },
        convert_urls: false,
        automatic_uploads: false,
        remove_linebreaks: false,
        link_title: true,
        relative_urls: false,
        paste_data_images: false,
        remove_script_host: false,
        nonbreaking_force_tab: true, // inserting nonbreaking space &nbsp; need Nonbreaking Space Plugin
        init_instance_callback: editor => {
          if (_this.value) {
            editor.setContent(_this.value)
          }
          _this.hasInit = true
          editor.on('NodeChange Change KeyUp SetContent', () => {
            this.hasChange = true
            this.$emit('input', editor.getContent())
          })

          editor.on('paste', (evt) => {
            // 监听粘贴事件
            _this.onPaste(evt)
          })
        },

        setup(editor) {
          editor.on('FullscreenStateChanged', (e) => {
            _this.fullscreen = e.state
          })
        },
        // it will try to keep these URLs intact
        // https://www.tiny.cloud/docs-3x/reference/configuration/Configuration3x@convert_urls/
        // https://stackoverflow.com/questions/5196205/disable-tinymce-absolute-to-relative-url-conversions
        // convert_urls: true,
        // automatic_uploads: true
        // 整合七牛上传
        // images_upload_handler(blobInfo, success, failure, progress) {
        //   console.log("images_upload_handler" )
        //   progress(0);
        //   const formData = new FormData();
        //   // formData.append('file', blobInfo.blob() );
        //   formData.append('file', blobInfo.blob(), blobInfo.filename());
        //   axios.post(this.uploadUrl, formData).then(res => {
        //     console.log("res", res)
        //     success( res.data.filename );
        //   }) .catch(err => {
        //       failure("出现未知问题");
        //       console.log(err);
        //     });
        //   }
      })
    },
    destroyTinymce() {
      const tinymce = window.tinymce.get(this.tinymceId)
      if (this.fullscreen) {
        tinymce.execCommand('mceFullScreen')
      }

      if (tinymce) {
        tinymce.destroy()
      }
    },
    uploadBefore(file) {
      const maxSize = file.size / 1024 / 1024 < 20;
      if (!maxSize) {
        this.$message.error('每个文件最大20M');
      }
      return maxSize;
    },
    uploadSuccess(res, file) {
      console.log( res, file.name )
      if (res.code === 200) {
        window.tinymce.get(this.tinymceId).insertContent(
        `<p><a target="_blank" style="cursor:hand;color:blue;display: block;" href="http://smoa.ndjsxh.cn:8888/preview/${res.data.filename}">${file.name}</a></p>`)
      } else {
        this.$message.error('图片上传失败')
      }
    },
    onPaste(e) {
      var items=e.clipboardData.items;
      var item = items[0];
      if ( item.kind != 'file' || item.type.indexOf('image/') == -1 ) {
        return
      }
      var file = item.getAsFile();
      const formData = new FormData()
      formData.append('file', file)
      // 上传图片
      axios.post(this.uploadUrl, formData, { headers: this.headers }).then(res => {
      if (res.data.code === 200) {
        window.tinymce.get(this.tinymceId).insertContent(`<img style="width:100%" src="http://smoa.ndjsxh.cn:8888/preview/${res.data.data.filename}" >`)
      } else {
        this.$message.error('图片上传失败,联系开发人员')
        }
      })
    },

    setContent(value) {
      window.tinymce.get(this.tinymceId).setContent(value)
    },
    getContent() {
      window.tinymce.get(this.tinymceId).getContent()
    },
    imageSuccessCBK(arr) {
      arr.forEach(v => window.tinymce.get(this.tinymceId).insertContent(`<img style="width:100%" src="${v.url}" >`))
    }
  }
}
</script>

<style lang="scss" scoped>
.tinymce-container {
  position: relative;
  line-height: normal;
}

.tinymce-container {
  ::v-deep {
    .mce-fullscreen {
      z-index: 10000;
    }
  }
}

.tinymce-textarea {
  visibility: hidden;
  z-index: -1;
}

.editor-custom-btn-container {
  position: absolute;
  right: 4px;
  top: 4px;
  /*z-index: 2005;*/
}

.fullscreen .editor-custom-btn-container {
  z-index: 10000;
  position: fixed;
}

.editor-upload-btn {
  display: inline-block;
}

.mlr10{ margin-left: 10px; margin-right: 10px;}
</style>
